Index: trunk/bugzcxx/bugzcxx.h
===================================================================
--- trunk/bugzcxx/bugzcxx.h	(revision 23)
+++ trunk/bugzcxx/bugzcxx.h	(working copy)
@@ -16,6 +16,7 @@
 #include<bugzc/bugz_features.h>
 #include<bugzcxx/Exception.h>
 #include<string>
+#include<memory>
 
 /** Holds the Bugzilla C/C++ XML-RPC proxy C++ implementation. */
 namespace bugzcxx {
Index: trunk/bugzcxx/Makefile.am
===================================================================
--- trunk/bugzcxx/Makefile.am	(revision 23)
+++ trunk/bugzcxx/Makefile.am	(working copy)
@@ -13,7 +13,7 @@
 
 h_sources = bugzcxx.h Exception.h
 
-cc_sources = bugzcxx.cpp Exception.cpp
+cc_sources = bugzcxx.cpp
 
 library_includedir=$(includedir)/bugzcxx
 
@@ -26,4 +26,3 @@
 libbugzcxx_la_LDFLAGS= -version-info $(GENERIC_LIBRARY_VERSION) -release $(GENERIC_RELEASE)
 
 rebuild: clean all
- 
\ No newline at end of file
Index: trunk/bugzc/bugzc_bug.h
===================================================================
--- trunk/bugzc/bugzc_bug.h	(revision 23)
+++ trunk/bugzc/bugzc_bug.h	(working copy)
@@ -76,8 +76,8 @@
  *  @param bug_obj The bugzc_obj to be released from memory. 
  *  @deprecated Please use bugzc_bug_destroy_obj2, as of BugzCXX 0.1.0 this
  *  function will be eliminated.*/
-void bugzc_bug_destroy_obj(bugzc_bug **bug_obj);
-
+void bugzc_bug_destroy_obj(bugzc_bug **bug_obj)
+				__attribute__ ((__deprecated__));
 /** @brief Call this method to release a bugzc_bug object from memory.
  *  After a succesfull call to bugzc_bug_create_obj a bugzc_bug object
  *  must be released from memory by calling this function since it will
@@ -122,7 +122,8 @@
 int bugzc_bug_legal_values(bugzc_conn *conn, const char *field,
 				const char *product_name, 
 				char *list, size_t nitems,
-				size_t max_vsize);
+				size_t max_vsize)
+				__attribute__ ((__deprecated__));
 /** @brief Returns a list of valid values related to the given Bugzilla
  *  field for a specified product.
  *  @param conn A properly initialized bugz_conn object describing the
@@ -183,11 +184,10 @@
  *  	use most be released from memory with an appropiate call to 
  *  	bugzc_bug_destry_list. */
 bugzc_bug *bugzc_bug_get_bugs(bugzc_conn *conn, unsigned int *bug_ids,
-				size_t nbugid, size_t *rbugid);
+				size_t nbugid, size_t *rbugid)
+				__attribute__ ((__deprecated__));
 
 /** @brief Gives detailed information about a bugid or an array of bug ids.
- *  @deprecated Instead use bugzc_bug_get_bugs_list as of BugzCXX 0.1.0 the
- *  function bugzc_bug_get_bugs will be eliminated.
  *  @param conn A properly initialized bugz_conn object describing the
  *  	url of the Bugzilla server.
  *  @param bug_ids An array of numeric bug ids to query from the Bugzilla
Index: trunk/examples/bugzc/get_bugs.c
===================================================================
--- trunk/examples/bugzc/get_bugs.c	(revision 23)
+++ trunk/examples/bugzc/get_bugs.c	(working copy)
@@ -13,6 +13,7 @@
 #include<stdio.h>
 #include<string.h>
 #include<stdlib.h>
+#include<unistd.h>
 #include<bugzc/bugzc.h>
 
 void print_bug_obj(bugzc_bug *l){
@@ -35,25 +36,13 @@
 int main(int argc, char *argv[]){
 	char *url;
 	char *login;
-	char pw[24];
+	char *pass;
 	char version[12];
 	int i;
 
-	char product[65];
-	char component[65];
-	char summary[256];
-	char bversion[65];
 	char description[2048];
-	char op_sys[65];
-	char platform[65];
-	char priority[65];
-	char severity[65];
-	char tmp[128];
-	int bug_id;
-	int *qi;
-	size_t n;
+	unsigned int *qi;
 	bugzc_conn conn;
-	bugzc_bug *l = 0;
 	bugzc_list list;
 
 	description[0] = 0;
@@ -85,10 +74,9 @@
 		fprintf(stderr, "%s\n", conn.xenv.fault_string);
 		return 1;
 	}
-	printf("Password: ");
-	fgets(pw, 23, stdin);
+	pass = getpass("Enter bugzilla password: ");
 	/* Perform login */
-	if(bugzc_user_login(&conn, login, pw, 0) < 0){
+	if(bugzc_user_login(&conn, login, pass, 0) < 0){
 		if(conn.err_code != 0){
 			fprintf(stderr, "\n");
 			if(conn.xenv.fault_occurred){
@@ -101,15 +89,13 @@
 		}
 		return 1;
 	}
-	
-	qi = (int *)malloc((argc - 3) * sizeof(int));
-	
+
+	qi = (unsigned int *)malloc((argc - 3) * sizeof(int));
+
 	/* Build bug array list */
 	for(i = 3; i < argc; i++){
 		sscanf(argv[i], "%d", &qi[i - 3]);
 		printf("Querying info for #%d...\n", qi[i - 3]);
-		
-		
 	}
 	if(bugzc_bug_get_bugs_list(&conn, qi, argc - 3, &list) >= 0){
 		print_bug_list(&list);