diff --git a/BuildRootCheck.py b/BuildRootCheck.py
index 6d606b2..71be1cd 100644
--- a/BuildRootCheck.py
+++ b/BuildRootCheck.py
@@ -21,7 +21,7 @@
 
 import SpecCheck
 import ReviewSpec
-from Filter import *        
+from Filter import *
 import re
 
 # Allowed expressions for the buildroot tag by Fedora:
@@ -94,7 +94,6 @@ It needs to be one of these three:\n
 '''Buildroot must be set to one of these three expressions:
     %(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)
     %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
-    %{_tmppath}/%{name}-%{version}-%{release}-root'''
-)
+    %{_tmppath}/%{name}-%{version}-%{release}-root''')
 
 # SpecCheck ends here
diff --git a/Filter.py b/Filter.py
index 180e4b5..501b628 100644
--- a/Filter.py
+++ b/Filter.py
@@ -20,11 +20,13 @@ import sys
 
 _details={}
 
+
 def addDetails(*details):
     """ """
     for idx in range(len(details)/2):
         _details[details[idx*2]]=details[idx*2+1]
 
+
 def printDescriptions(reason):
     """ """
     try:
@@ -35,26 +37,31 @@ def printDescriptions(reason):
     except KeyError:
         pass
 
+
 def printInfo(spec, reason, *details):
     """ """
     # I => Info
     _print("I", spec, reason, details)
 
+
 def printMust(spec, reason, *details):
     """ """
     # M => Must
     _print("M", spec, reason, details)
 
+
 def printShould(spec, reason, *details):
     """ """
     # S => Should
     _print("S", spec, reason, details)
 
+
 def printError(spec, reason, *details):
     """ """
     # E => Error
     _print("E", spec, reason, details)
 
+
 def printWarning(spec, reason, *details):
     """ """
     # W => Warning
@@ -72,7 +79,7 @@ def _print(type, spec, reason, details):
     for d in details:
         output_string = output_string + " %s" %d
 
-    output_string += "\n";
+    output_string += "\n"
     sys.stdout.write(output_string)
 
 # filter ends here
diff --git a/FindDownload.py b/FindDownload.py
index 4a048e2..55dbc1a 100644
--- a/FindDownload.py
+++ b/FindDownload.py
@@ -24,10 +24,11 @@ import urllib2
 
 download_dir = "./downloads/"
 
+
 class FindDownload:
     """This will find and download spec and srpm"""
 
-    def __init__(self,bugid):
+    def __init__(self, bugid):
         """Init method"""
         page = "https://bugzilla.redhat.com/show_bug.cgi?id=" + str(bugid)
         f = urllib2.urlopen(page)
@@ -44,7 +45,7 @@ class FindDownload:
         print "Downloading SPEC"
         specdata = f.read()
         specname = os.path.basename(spec)
-        f = open(os.path.join(download_dir,str(bugid),specname),"w")
+        f = open(os.path.join(download_dir, str(bugid), specname), "w")
         f.write(specdata)
         f.close()
 
@@ -58,8 +59,9 @@ class FindDownload:
         print "Downloading SRPM"
         srpmdata = f.read()
         srpmname = os.path.basename(srpm)
-        f = open(os.path.join(download_dir,str(bugid),srpmname),"wb")
+        f = open(os.path.join(download_dir, str(bugid), srpmname), "wb")
         f.write(srpmdata)
         f.close()
-        self.path = os.path.join(download_dir,str(bugid))
-        self.data = (os.path.join(download_dir,str(bugid),srpmname), os.path.join(download_dir,str(bugid),specname))
+        self.path = os.path.join(download_dir, str(bugid))
+        self.data = (os.path.join(download_dir, str(bugid), srpmname), \
+                         os.path.join(download_dir, str(bugid), specname))
diff --git a/ReviewSpec.py b/ReviewSpec.py
index e194d43..ecd0619 100644
--- a/ReviewSpec.py
+++ b/ReviewSpec.py
@@ -29,12 +29,14 @@ import SpecCheck
 
 version='0.01'
 
+
 def usage(name):
     """Print Usage Information"""
     print 'usage:', name, '[<option>] <specfile>'
     print '  options in:'
     print '\t[-i|--info]\n\t[-g|--guideline <guideline>]\n\t[-G|--guidelinedir <guidelinedir>]\n\t[-v|--verbose]\n\t[-V|--version]\n\t[-h|--help]'
 
+
 def printVersion():
     """Print Version Information"""
     print 'reviewspec version', version, 'Copyright (C) 2008 Rakesh Pandit, Fedora'
@@ -48,8 +50,7 @@ try:
                                      'verbose',
                                      'version',
                                      'help'
-                                     'info'
-                                     ])
+                                     'info'])
 
 except getopt.error, e:
     usage(sys.argv[0])
@@ -58,7 +59,7 @@ except getopt.error, e:
 if not args and not options:
     usage(sys.argv[0])
     sys.exit(1)
-    
+
 # Default options
 verbose = 0
 _directories = [".", "/usr/share/reviewspec"]
@@ -67,8 +68,7 @@ info=0
 
 DEFAULT_GUIDELINES=(  # Add all default checks here
     "SampleCheck",
-    "BuildRootCheck"
-    )
+    "BuildRootCheck")
 
 # Command line options
 for opt in options:
@@ -87,7 +87,7 @@ for opt in options:
         dir = opt[1]
         dirpath = os.path.expanduser(dir)
 
-        if not  dirpath in _directories:
+        if not dirpath in _directories:
             _directories.insert(0, dirpath)
 
     if opt[0] == '-g' or opt[0] == '--guideline':
@@ -99,7 +99,7 @@ for opt in options:
     if opt[0] == '-v' or opt[0] == '--verbose':
         verbose = 1
 
-      
+
 def review():
     """Main review function"""
 
@@ -111,7 +111,7 @@ def review():
     if _checks == []:
         _checks += (DEFAULT_GUIDELINES)
     for name in _checks:
-        try: 
+        try:
             (file, path, description) = imp.find_module(name, _directories)
         except ImportError:
             print "The guideline is not present in any of locations: ", _directories
@@ -155,7 +155,7 @@ def review():
                 # Once Spec class is designed uncomment
                 runReviewChecks(spec)
                 review_done += 1
-        
+
         # Directories
         for d in dirs:
             try:
@@ -202,9 +202,10 @@ def review():
     finally:
         print "%d specs reviewed." % review_done
 
+
 def runReviewChecks(spec):
     if verbose:
-        print "checking ", spec.getName() , "..."
+        print "checking ", spec.getName(), "..."
 
     # Run all guidelines
     for guide in SpecCheck.SpecCheck.checks:
diff --git a/RomBuilder.py b/RomBuilder.py
index 480d8ea..21b7282 100644
--- a/RomBuilder.py
+++ b/RomBuilder.py
@@ -16,6 +16,7 @@
 # along with translate; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
+
 class RomBuilder:
     """
     Abstract builder interface to be implemented by derived classes.
diff --git a/RomKojiBuilder.py b/RomKojiBuilder.py
index 2fa400c..34e745f 100644
--- a/RomKojiBuilder.py
+++ b/RomKojiBuilder.py
@@ -23,6 +23,7 @@ import string
 import time
 import RomBuilder
 
+
 def _unique_path(prefix):
     """
     Taken from the Koji client: /usr/bin/koji
@@ -65,7 +66,7 @@ class RomKojiBuilder(RomBuilder.RomBuilder):
         server_dir = _unique_path("rom-build")
         session.uploadWrapper(source, server_dir)
         server_source = server_dir + "/" + os.path.basename(source)
-        build_opts = {"scratch" : True, "skip_tag" : None}
+        build_opts = {"scratch": True, "skip_tag": None}
         self.taskId = session.build(server_source, target, build_opts)
 
         session.logout()
diff --git a/SampleCheck.py b/SampleCheck.py
index 4fd7fc5..78307a5 100644
--- a/SampleCheck.py
+++ b/SampleCheck.py
@@ -18,7 +18,8 @@
 
 import SpecCheck
 import ReviewSpec
-from Filter import *        
+from Filter import *
+
 
 class SampleCheck(SpecCheck.SpecCheck):
     """Sample test"""
@@ -37,7 +38,6 @@ check=SampleCheck()
 if ReviewSpec.info:
     addDetails(
 'sample-testing',
-'''The is a sample check'''
-)
+'''The is a sample check''')
 
 # SpecCheck ends here
diff --git a/Spec.py b/Spec.py
index 30c47f1..3ef98f0 100644
--- a/Spec.py
+++ b/Spec.py
@@ -19,9 +19,10 @@
 import re
 import string
 
+
 class Spec(object):
     """Spec file class """
-    
+
     def __init__(self, filename):
         """ """
         self.filename=filename
@@ -84,6 +85,7 @@ class Spec(object):
             fobj.close()
 
     # Get functions
+
     def getSpecname(self):
         """ Returns spec file name."""
         return self.filename
@@ -158,7 +160,7 @@ class Spec(object):
 
     def getFiles(self):
         """ Returns %files section."""
-        return self.files;
+        return self.files
 
     def getChangelog(self):
         """ Returns %changelog section."""
@@ -173,6 +175,7 @@ class Spec(object):
         return self.check
 
     # Set functions
+
     def __setSpecname(self, filename):
         """ Set spec file name."""
         self.filename = filename
@@ -243,7 +246,7 @@ class Spec(object):
 
     def __setFiles(self, files):
         """ Set files section."""
-        self.files = files;
+        self.files = files
 
     def __setChangelog(self, changelog):
         """ Set changelog section."""
@@ -284,13 +287,13 @@ class Spec(object):
         # Logic to differentiate between sections.
         for line in self.__spec_lines:
             self.current_linenum += 1
-            
+
             section_marker = 0
             for i in section.keys():
                 if section[i]["re"].search(line):
                     current_section = i
                     section_marker = 1
-                    
+
             section[current_section]["content"].append(line)
 
         # Set the attributes with content.
@@ -310,4 +313,3 @@ class Spec(object):
         return
 
 # Spec ends here
-
diff --git a/SpecCheck.py b/SpecCheck.py
index ba4c470..4354205 100644
--- a/SpecCheck.py
+++ b/SpecCheck.py
@@ -20,6 +20,7 @@
 # Every Check file needs to inherit this class
 #
 
+
 class SpecCheck:
     check_names_seen = []
     checks = []
diff --git a/Srpm.py b/Srpm.py
index 85e6908..3e1a862 100644
--- a/Srpm.py
+++ b/Srpm.py
@@ -19,6 +19,7 @@
 import os
 import rpm
 
+
 class Srpm:
     """Represents a source RPM"""
 
diff --git a/SrpmCheck.py b/SrpmCheck.py
index e328ca5..6925a00 100644
--- a/SrpmCheck.py
+++ b/SrpmCheck.py
@@ -14,6 +14,7 @@
 # along with translate; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
+
 class SrpmCheck:
     """ Abstract base class for all source RPM checks"""
 
diff --git a/rom.py b/rom.py
index ea83c49..c6c1f4f 100755
--- a/rom.py
+++ b/rom.py
@@ -32,13 +32,13 @@ from ConfigParser import ConfigParser
 cf = ConfigParser()
 
 cf.readfp(open('/etc/rom.config'))
-username = cf.get("Details",'username')
-password = cf.get("Details",'password')
-
-
+username = cf.get("Details", 'username')
+password = cf.get("Details", 'password')
 
 koji_getfile = "http://koji.fedoraproject.org/koji/getfile"
 KOJI_URL = 'http://koji.fedoraproject.org/kojihub'
+
+
 def _mock_error_code_to_log_file(err_code):
     log_file = ''
     if err_code == 1:
@@ -49,8 +49,9 @@ def _mock_error_code_to_log_file(err_code):
         print "Unhandled error code :", err_code
     return log_file
 
+
 def get_files(**kw):
-    results = {'logs':{'count':0}, 'downloads':{'count':0}}
+    results = {'logs': {'count': 0}, 'downloads': {'count': 0}}
     task_id = int(kw.get('task_id', '0'))
     state = int(kw.get('state', '0'))
 
@@ -92,7 +93,7 @@ def get_files(**kw):
 
 
 def get_error_log(**kw):
-    results = {'log_url':'', 'log_name':'', 'task_id':''}
+    results = {'log_url': '', 'log_name': '', 'task_id': ''}
     task_id = int(kw.get('task_id', '0'))
 
     cs = koji.ClientSession(KOJI_URL)
@@ -106,7 +107,7 @@ def get_error_log(**kw):
 
                 error_code = 0
                 try:
-                    # this should throw an error 
+                    # this should throw an error
                     child_result = cs.getTaskResult(child_task_id)
                 except koji.BuildrootError, e:
                     error = str(e)
@@ -134,14 +135,16 @@ def get_error_log(**kw):
 
     return results
 
-def download(link,filepath):
+
+def download(link, filepath):
     f = urllib2.urlopen(link)
     print "Downloading:", link
     data = f.read()
-    f = open(filepath,'wb')
+    f = open(filepath, 'wb')
     f.write(data)
     f.close()
 
+
 def main():
     """The main function"""
     bugid = int(raw_input("Enter the bug number: "))
@@ -151,7 +154,7 @@ def main():
     koji_id = None
     kojilink = ""
     bz = bugzilla.Bugzilla(url='https://bugzilla.redhat.com/xmlrpc.cgi')
-    bz.login(username,password)
+    bz.login(username, password)
     bug = bz.getbug(bugid)
     for line in txts:
         if line.startswith("Task info:"):
@@ -169,8 +172,8 @@ def main():
             if key != "count":
                 links = z[key]
                 for link in links:
-                    download(link['url'],os.path.join(fd.path,link['name']))
-        message = os.popen('rpmlint ' + os.path.join(fd.path,'*.rpm') + ' '+os.path.join(fd.path,'*.spec')).read()
+                    download(link['url'], os.path.join(fd.path, link['name']))
+        message = os.popen('rpmlint ' + os.path.join(fd.path, '*.rpm') + ' '+ os.path.join(fd.path, '*.spec')).read()
     message = "Automated result from review-o-matic\n\n" + kojilink +"\n\n" + message
     print message
     bug.addcomment(message)
@@ -179,5 +182,3 @@ def main():
 
 if __name__ == '__main__':
     main()
-
-