Only in entrans/conf: database.conf.php
diff -ur entrans.org/footer.php entrans/footer.php
--- entrans.org/footer.php	2008-11-17 03:03:13.000000000 +0530
+++ entrans/footer.php	2008-11-17 03:02:28.000000000 +0530
@@ -39,6 +39,9 @@
 	<li><a href="contact.php">Contact us</a></li>
 	<li><a href="http://validator.w3.org/check?uri=referer"><img border="0" src="http://www.w3.org/Icons/valid-html401"
         	  alt="Valid HTML 4.01!" height="31" width="88"></a></li>
+
+    <!-- As we are using google API -->
+        <div class="gBranding" style="color: rgb(103, 103, 103);"><span class="gBrandingText" style="vertical-align: middle; font-family: arial,sans-serif; font-size: 11px;">Auto translation plugin powered by<img src="http://www.google.com/uds/css/small-logo.png" style="padding-left: 1px; vertical-align: middle;"/></span></div>
     </ul>
 
 </div>
Only in entrans: footer.php~
diff -ur entrans.org/include/header_info.php entrans/include/header_info.php
--- entrans.org/include/header_info.php	2008-11-17 03:03:13.000000000 +0530
+++ entrans/include/header_info.php	2008-11-17 03:02:28.000000000 +0530
@@ -7,5 +7,4 @@
 session_start();				// Start Session
 header("Cache-control: private");		// IE6 Fix
 header("Content-type: text/html; charset=UTF-8");
-
 ?>
Only in entrans/include: header_info.php~
diff -ur entrans.org/list.php entrans/list.php
--- entrans.org/list.php	2008-11-17 03:03:13.000000000 +0530
+++ entrans/list.php	2008-11-17 03:02:28.000000000 +0530
@@ -388,10 +388,14 @@
 }
 // -->
 </style>
+<meta http-equiv="content-type" content="text/html; charset=utf-8"/>
+<script type="text/javascript" src="http://www.google.com/jsapi"></script>
+<script type="text/javascript">
+      google.load("language", "1");
+</script>
 <script type="text/javascript" src="scripts/list.js"> </script>
 <script type="text/javascript" src="scripts/common.js"> </script>
 <script type="text/javascript" src="scripts/IndicSupport.js"> </script>
-
     <script type="text/javascript" >
     <!--
         // -->
@@ -957,6 +961,7 @@
                                 <a href="#" onClick="submitAndMove()" ><img 
                             src="images/submit.png" alt="Submit"></a>
                           </td>
+                            <td align="left"><input type="button" onClick="SuggestTranslation()" >Suggest</input></td>
                           <td align="center">
                             <input type="checkbox" name="fuzzy" >Fuzzy
                           </td>
@@ -1260,7 +1265,8 @@
                             <td  align="left">
                                     <a href="#" onClick="submitAndMove()" ><img 
                                src="images/submit.png" alt="Submit"></a>
-                            </td>
+                            <td align="left"><input type="button" onClick="SuggestTranslation()" >Suggest</input></td>
+			    </td>
                             <td align="center">
                               <input type="checkbox" name="fuzzy" >Fuzzy
                              </td>
@@ -1441,7 +1447,6 @@
 </table>
 -->
 </div> 
-
 <div id="droplegends" class="dropmenudiv" >
     <span>
         <img src="images/valid.png" height="15" hspace=5 alt="Valid: "> &nbsp; Valid Translation
Only in entrans: list.php~
Only in entrans/logs: pid_file
Only in entrans/logs: updatedb_log_testing_20081116
diff -ur entrans.org/scripts/list.js entrans/scripts/list.js
--- entrans.org/scripts/list.js	2008-11-17 03:03:13.000000000 +0530
+++ entrans/scripts/list.js	2008-11-17 03:04:49.000000000 +0530
@@ -327,3 +327,40 @@
 
         window.location = new_href;
     }
+
+function SuggestTranslation()
+{
+    form = document.getElementsByName('edit_form')[0];
+    var string_id = document.edit_form.string_id.value;
+    myGetElementByClass('tdborder');
+
+    index = (parseInt(string_id)%100);
+
+    // Rows for each translation
+    tags = groupClass[index].getElementsByTagName('td');
+    html = tags[1].innerHTML; 
+    
+    // Extract english string from html
+    /<a\s.*?>(.*?)<\/a>/.test(html);
+    english_string = RegExp.$1;
+
+    // Google API
+    google.language.translate(english_string, "en", "hi", function(result) {
+	    if (!result.error) {
+		if (result.translation) {
+		    //var translated = document.getElementById("result"); 
+		    translated_string = result.translation;
+		    replace = confirm("Translated text: \"" + translated_string + "\" . Use it?");
+
+		    // On confirmation from user replace the user suggestion text area entry.
+		    if (replace) {
+			document.getElementsByName("edit_form")[0].user_sug.value = translated_string;
+		    }
+
+		    //translation.innerHTML = result.translation;
+		} else {
+		    alert('ERROR: Impossible to translate'); 
+		}
+	    }
+	});
+}
Only in entrans/uploads: temp_download
Only in entrans/uploads: temp_upload