diff --git a/rpmqv.c b/rpmqv.c
index bc1dc60..806f1e2 100644
--- a/rpmqv.c
+++ b/rpmqv.c
@@ -159,6 +159,10 @@ static void printUsage(poptContext con, FILE * fp, int flags)
 int main(int argc, char *argv[])
 {
     rpmts ts = NULL;
+    int option;
+    char* arg1;
+    ARGV_t abc;
+    char** fnp;
     enum modes bigMode = MODE_UNKNOWN;
 
 #if defined(IAM_RPMQV)
@@ -360,7 +364,7 @@ int main(int argc, char *argv[])
 	int eflags = (ia->installInterfaceFlags & INSTALL_ERASE);
 
 	if (iflags && eflags)
-	    argerror(_("only one major mode may be specified"));
+	    bigMode = MODES_IE;
 	else if (iflags)
 	    bigMode = MODE_INSTALL;
 	else if (eflags)
@@ -390,41 +394,46 @@ int main(int argc, char *argv[])
 #endif	/* IAM_RPMK */
 
 #if defined(IAM_RPMEIU)
-    if (!( bigMode == MODE_INSTALL ) &&
+    if (!( bigMode == MODE_INSTALL || bigMode == MODES_IE) &&
 (ia->probFilter & (RPMPROB_FILTER_REPLACEPKG | RPMPROB_FILTER_OLDPACKAGE)))
 	argerror(_("only installation, upgrading, rmsource and rmspec may be forced"));
-    if (bigMode != MODE_INSTALL && (ia->probFilter & RPMPROB_FILTER_FORCERELOCATE))
+    if ((bigMode != MODE_INSTALL && bigMode != MODES_IE) &&
+	(ia->probFilter & RPMPROB_FILTER_FORCERELOCATE))
 	argerror(_("files may only be relocated during package installation"));
 
     if (ia->relocations && ia->prefix)
 	argerror(_("cannot use --prefix with --relocate or --excludepath"));
 
-    if (bigMode != MODE_INSTALL && ia->relocations)
+    if ((bigMode != MODE_INSTALL && bigMode != MODES_IE) && ia->relocations)
 	argerror(_("--relocate and --excludepath may only be used when installing new packages"));
 
-    if (bigMode != MODE_INSTALL && ia->prefix)
+    if ((bigMode != MODE_INSTALL && bigMode != MODES_IE) && ia->prefix)
 	argerror(_("--prefix may only be used when installing new packages"));
 
     if (ia->prefix && ia->prefix[0] != '/') 
 	argerror(_("arguments to --prefix must begin with a /"));
 
-    if (bigMode != MODE_INSTALL && (ia->installInterfaceFlags & INSTALL_HASH))
+    if ((bigMode != MODE_INSTALL && bigMode != MODES_IE) &&
+	(ia->installInterfaceFlags & INSTALL_HASH))
 	argerror(_("--hash (-h) may only be specified during package "
 			"installation"));
 
-    if (bigMode != MODE_INSTALL && (ia->installInterfaceFlags & INSTALL_PERCENT))
+    if ((bigMode != MODE_INSTALL && bigMode != MODES_IE) &&
+	(ia->installInterfaceFlags & INSTALL_PERCENT))
 	argerror(_("--percent may only be specified during package "
 			"installation"));
 
-    if (bigMode != MODE_INSTALL && (ia->probFilter & RPMPROB_FILTER_REPLACEPKG))
+    if ((bigMode != MODE_INSTALL && bigMode != MODES_IE) &&
+	(ia->probFilter & RPMPROB_FILTER_REPLACEPKG))
 	argerror(_("--replacepkgs may only be specified during package "
 			"installation"));
 
-    if (bigMode != MODE_INSTALL && (ia->transFlags & RPMTRANS_FLAG_NODOCS))
+    if ((bigMode != MODE_INSTALL && bigMode != MODES_IE) &&
+	(ia->transFlags & RPMTRANS_FLAG_NODOCS))
 	argerror(_("--excludedocs may only be specified during package "
 		   "installation"));
 
-    if (bigMode != MODE_INSTALL && ia->incldocs)
+    if ((bigMode != MODE_INSTALL && bigMode != MODES_IE) && ia->incldocs)
 	argerror(_("--includedocs may only be specified during package "
 		   "installation"));
 
@@ -432,39 +441,44 @@ int main(int argc, char *argv[])
 	argerror(_("only one of --excludedocs and --includedocs may be "
 		 "specified"));
   
-    if (bigMode != MODE_INSTALL && (ia->probFilter & RPMPROB_FILTER_IGNOREARCH))
+    if ((bigMode != MODE_INSTALL && bigMode != MODES_IE) && (ia->probFilter &
+							     RPMPROB_FILTER_IGNOREARCH))
 	argerror(_("--ignorearch may only be specified during package "
 		   "installation"));
 
-    if (bigMode != MODE_INSTALL && (ia->probFilter & RPMPROB_FILTER_IGNOREOS))
+    if ((bigMode != MODE_INSTALL && bigMode != MODES_IE) && (ia->probFilter &
+							     RPMPROB_FILTER_IGNOREOS))
 	argerror(_("--ignoreos may only be specified during package "
 		   "installation"));
 
-    if (bigMode != MODE_INSTALL && bigMode != MODE_ERASE &&
+    if (bigMode != MODE_INSTALL && bigMode != MODE_ERASE && bigMode != MODES_IE &&
 	(ia->probFilter & (RPMPROB_FILTER_DISKSPACE|RPMPROB_FILTER_DISKNODES)))
 	argerror(_("--ignoresize may only be specified during package "
 		   "installation"));
 
-    if ((ia->installInterfaceFlags & UNINSTALL_ALLMATCHES) && bigMode != MODE_ERASE)
+    if ((ia->installInterfaceFlags & UNINSTALL_ALLMATCHES) && (bigMode != MODE_ERASE &&
+							       bigMode != MODES_IE))
 	argerror(_("--allmatches may only be specified during package "
 		   "erasure"));
 
-    if ((ia->transFlags & RPMTRANS_FLAG_ALLFILES) && bigMode != MODE_INSTALL)
+    if ((ia->transFlags & RPMTRANS_FLAG_ALLFILES) && (bigMode != MODE_INSTALL &&
+						      bigMode != MODES_IE))
 	argerror(_("--allfiles may only be specified during package "
 		   "installation"));
 
     if ((ia->transFlags & RPMTRANS_FLAG_JUSTDB) &&
-	bigMode != MODE_INSTALL && bigMode != MODE_ERASE)
+	bigMode != MODE_INSTALL && bigMode != MODE_ERASE && bigMode != MODES_IE)
 	argerror(_("--justdb may only be specified during package "
 		   "installation and erasure"));
 
     if (bigMode != MODE_INSTALL && bigMode != MODE_ERASE && bigMode != MODE_VERIFY &&
+	bigMode != MODES_IE &&
 	(ia->transFlags & (RPMTRANS_FLAG_NOSCRIPTS | _noTransScripts | _noTransTriggers)))
 	argerror(_("script disabling options may only be specified during "
 		   "package installation and erasure"));
 
     if (bigMode != MODE_INSTALL && bigMode != MODE_ERASE && bigMode != MODE_VERIFY &&
-	(ia->transFlags & (RPMTRANS_FLAG_NOTRIGGERS | _noTransTriggers)))
+	bigMode != MODES_IE && (ia->transFlags & (RPMTRANS_FLAG_NOTRIGGERS | _noTransTriggers)))
 	argerror(_("trigger disabling options may only be specified during "
 		   "package installation and erasure"));
 
@@ -700,6 +714,20 @@ int main(int argc, char *argv[])
 #endif	/* IAM_RPMBT */
 
 #ifdef	IAM_RPMEIU
+    case MODES_IE:
+    while ((option = poptGetNextOpt(optCon)) > 0) {
+      arg1 = poptGetOptArg(optCon);
+      fprintf(stderr, "Arg: %s\n", arg1);
+    }
+    fprintf(stderr, "Error with %s: %s\n", poptBadOption(optCon, POPT_BADOPTION_NOALIAS), poptStrerror(option));
+/* 	abc = poptGetArgs(optCon); */
+/*       for (fnp = abc; *fnp != NULL; fnp++) { */
+/* 	fprintf(stderr, "Arg: %s\n", *fnp); */
+/*       } */
+      /*      rpmlog(RPMLOG_NOTICE, "Args:  %s", (ARGV_const_t) poptGetArgs(optCon));*/
+/*       fprintf(stdout, "", ); */
+	argerror(_("Hybrid mode"));
+	break;
     case MODE_ERASE:
 	if (ia->noDeps) ia->installInterfaceFlags |= UNINSTALL_NODEPS;
 